import { createActionHandlerDecorator } from "./index";
/**
 * If specified, the action cannot be entered by other sagas during execution.
 * For error handler action, mutex logic is auto added.
 */
export function Mutex() {
    let isLocked = false;
    return createActionHandlerDecorator(function* (handler) {
        if (!isLocked) {
            try {
                isLocked = true;
                yield* handler();
            }
            finally {
                isLocked = false;
            }
        }
    });
}
//# sourceMappingURL=Mutex.js.map