import React from "react";
import { useDispatch, useSelector } from "react-redux";
export function useLoadingStatus(identifier = "global") {
    return useSelector((state) => state.loading[identifier] > 0);
}
/**
 * Action parameters must be of primitive types, so that the dependency check can work well.
 * No need add dispatch to dep list, because it is always fixed.
 */
export function useModuleAction(actionCreator, ...deps) {
    const dispatch = useDispatch();
    return React.useCallback(() => dispatch(actionCreator(...deps)), deps);
}
//# sourceMappingURL=hooks.js.map