import { StrictEffect, Effect, spawn, delay, put } from "redux-saga/effects";
declare type StrictObject<T extends {}> = T extends any[] ? never : T;
declare type SagaGenerator<RT> = Generator<Effect<any>, RT, any>;
declare type UnwrapReturnType<R> = R extends SagaGenerator<infer RT> ? RT : R extends Promise<infer PromiseValue> ? PromiseValue : R;
export declare type SagaIterator = IterableIterator<StrictEffect> | Iterator<StrictEffect, any, any>;
export declare function call<Args extends any[], R>(fn: (...args: Args) => R, ...args: Args): SagaGenerator<UnwrapReturnType<R>>;
export declare function race<T extends {}>(effects: StrictObject<T>): SagaGenerator<{
    [P in keyof T]?: UnwrapReturnType<T[P]>;
}>;
export declare function all<T extends {}>(effects: StrictObject<T>): SagaGenerator<{
    [P in keyof T]: UnwrapReturnType<T[P]>;
}>;
export { spawn, delay, put };
