import React from "react";
import { captureError } from "./error-util";
let ErrorBoundary = /** @class */ (() => {
    class ErrorBoundary extends React.PureComponent {
        constructor(props) {
            super(props);
            this.state = { exception: null };
        }
        componentDidCatch(error, errorInfo) {
            const exception = captureError(error, "@@framework/error-boundary", { extraStacktrace: errorInfo.componentStack });
            this.setState({ exception });
        }
        render() {
            return this.state.exception ? this.props.render(this.state.exception) : this.props.children || null;
        }
    }
    ErrorBoundary.displayName = "ErrorBoundary";
    ErrorBoundary.defaultProps = { render: () => null };
    return ErrorBoundary;
})();
export { ErrorBoundary };
//# sourceMappingURL=ErrorBoundary.js.map